abuild.in 41.5 KB
Newer Older
Natanael Copa's avatar
Natanael Copa committed
1 2
#!/bin/sh

3
# script to build apk packages (light version of makepkg)
Natanael Copa's avatar
Natanael Copa committed
4 5 6 7 8 9 10
# Copyright (c) 2008 Natanael Copa <natanael.copa@gmail.com>
#
# Distributed under GPL-2
#
# Depends on: busybox utilities, fakeroot, 
#

Natanael Copa's avatar
Natanael Copa committed
11 12
abuild_ver=@VERSION@
sysconfdir=@sysconfdir@
13
abuildrepo_base=@abuildrepo@
Natanael Copa's avatar
Natanael Copa committed
14
datadir=@datadir@
Natanael Copa's avatar
Natanael Copa committed
15

16
program=${0##*/}
17
abuild_path=$(readlink -f $0)
Natanael Copa's avatar
Natanael Copa committed
18 19

# defaults
20
BUILD_BASE="build-base"
21
FAKEROOT=${FAKEROOT:-"fakeroot"}
22

23 24
: ${SUDO_APK:=abuild-apk}
: ${APK:=apk}
25 26 27
: ${ADDUSER:=abuild-adduser}
: ${ADDGROUP:=abuild-addgroup}

28
apk_opt_wait="--wait 30"
29

Natanael Copa's avatar
Natanael Copa committed
30
# read config
Natanael Copa's avatar
Natanael Copa committed
31
ABUILD_CONF=${ABUILD_CONF:-"$sysconfdir/abuild.conf"}
Natanael Copa's avatar
Natanael Copa committed
32 33
[ -f "$ABUILD_CONF" ] && . "$ABUILD_CONF"

34
default_colors() {
Natanael Copa's avatar
Natanael Copa committed
35 36 37 38 39 40
	NORMAL="\033[1;0m"
	STRONG="\033[1;1m"
	RED="\033[1;31m"
	GREEN="\033[1;32m"
	YELLOW="\033[1;33m"
	BLUE="\033[1;34m"
41 42 43 44 45 46 47 48 49 50 51 52 53 54
}

monochrome() {
	NORMAL=""
	STRONG=""
	RED=""
	GREEN=""
	YELLOW=""
	BLUE=""
}

#colors
if [ -n "$USE_COLORS" ]; then
    default_colors
Natanael Copa's avatar
Natanael Copa committed
55 56 57 58 59
fi	
	

# functions
msg() {
60
	[ -n "$quiet" ] && return 0
Natanael Copa's avatar
Natanael Copa committed
61 62 63
	local prompt="$GREEN>>>${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
64 65 66 67 68 69 70
	printf "${prompt} ${name}${fake}: %s\n" "$1" >&2
}

msg2() {
	[ -n "$quiet" ] && return 0
	#      ">>> %s"
	printf "    %s\n" "$1" >&2
Natanael Copa's avatar
Natanael Copa committed
71 72 73 74 75 76
}

warning() {
	local prompt="${YELLOW}>>> WARNING:${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
77 78 79 80 81 82
	printf "${prompt} ${name}${fake}: %s\n" "$1" >&2
}

warning2() {
	#      ">>> WARNING: 
	printf "             %s\n" "$1" >&2
Natanael Copa's avatar
Natanael Copa committed
83 84 85 86 87 88
}

error() {
	local prompt="${RED}>>> ERROR:${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
89 90 91 92 93 94
	printf "${prompt} ${name}${fake}: %s\n" "$1" >&2
}

error2() {
	#      ">>> ERROR: 
	printf "           %s\n" "$1" >&2
Natanael Copa's avatar
Natanael Copa committed
95
}
Natanael Copa's avatar
Natanael Copa committed
96

Linux User's avatar
Linux User committed
97
set_xterm_title() {
98
	if [ "$TERM" = xterm ] && [ -n "$USE_COLORS" ]; then
99
		 printf "\033]0;$1\007" >&2
Linux User's avatar
Linux User committed
100 101 102 103 104
	fi
} 

cleanup() {
	set_xterm_title ""
105
	if [ -z "$install_after" ] && [ -n "$uninstall_after" ]; then
106
		msg "Uninstalling dependencies..."
107
		$SUDO_APK del --quiet $apk_opt_wait $uninstall_after
108
	fi
109 110 111
	if [ -n "$CLEANUP_FILES" ]; then
		rm -f $CLEANUP_FILES
	fi
Linux User's avatar
Linux User committed
112 113
}

Natanael Copa's avatar
Natanael Copa committed
114
die() {
Linux User's avatar
Linux User committed
115
	error "$@"
Linux User's avatar
Linux User committed
116
	cleanup
Natanael Copa's avatar
Natanael Copa committed
117 118 119
	exit 1
}

120
# check if apkbuild is basicly sane
121
default_sanitycheck() {
122
	local i= j= suggestion=
123
	msg "Checking sanity of $APKBUILD..."
124 125 126
	[ -z "$pkgname" ] && die "Missing pkgname in APKBUILD"
	[ -z "${pkgname##* *}" ] && die "pkgname contains spaces"
	[ -z "$pkgver" ] && die "Missing pkgver in APKBUILD"
127
	if [ "$pkgver" != "volatile" ] && [ -z "$nodeps" ]; then
128
		$APK version --check -q "$pkgver" ||\
Natanael Copa's avatar
Natanael Copa committed
129 130
			die "$pkgver is not a valid version"
	fi
131
	[ -z "$pkgrel" ] && die "Missing pkgrel in APKBUILD"
132 133 134 135
	[ -z "$pkgdesc" ] && die "Missing pkgdesc in APKBUILD"
	[ -z "$url" ] && die "Missing url in APKBUILD"
	[ -z "$license" ] && die "Missing license in APKBULID"

Natanael Copa's avatar
Natanael Copa committed
136 137
	if [ -n "$replaces_priority" ] \
		&& ! echo $replaces_priority | egrep -q '^[0-9]+$'; then
138 139
		die "replaces_priority must be a number"
	fi
140 141 142 143 144 145 146
	# check so no package names starts with -
	for i in $pkgname $subpackages; do
		case $i in
		-*) die "${i%:*} is not a valid package name";;
		esac
	done

147 148 149 150 151 152 153 154 155 156
	# check if CARCH, CBUILD, CHOST and CTARGET is set
	if [ -z "$CARCH" ]; then
		case "$(uname -m)" in
		i[0-9]86) suggestion=" (Suggestion: CARCH=x86)";;
		x86_64) suggestion=" (Suggestion: CARCH=x86_64)";;
		esac
		die "Please set CARCH in /etc/abuild.conf$suggestion"
	fi
	[ -z "$CHOST" ] && die "Please set CHOST in /etc/abuild.conf"

Natanael Copa's avatar
Natanael Copa committed
157
	for i in $install; do
158
		local n=${i%.*}
159
		local suff=${i##*.}
160 161 162 163 164
		case "$suff" in
		pre-install|post-install|pre-upgrade|post-upgrade|pre-deinstall|post-deinstall);;
		*) die "$i: unknown install script suffix"
		esac
		if ! subpackages_has "$n" && [ "$n" != "$pkgname" ]; then
165
			die "$i: install script does not match pkgname or any subpackage"
166
		fi
167
		[ -e "$startdir/$i" ] || die "install script $i is missing"
168 169 170 171 172 173
		for j in chown chmod chgrp; do
			if grep -q $j "$startdir"/$i; then
				warning "$i: found $j"
				warning2 "Permissions should be fixed in APKBUILD package()"
			fi
		done
Natanael Copa's avatar
Natanael Copa committed
174 175
	done
	
176 177 178 179 180 181 182 183
	for i in $triggers; do
		local f=${i%=*}
		local p=${f%.trigger}
		[ "$f" = "$i" ] && die "$f: triggers must contain '='" 
		[ "$p" = "$f" ] && die "$f: triggers scripts must have .trigger suffix"
		if ! subpackages_has "$p" && [ "$p" != "$pkgname" ]; then
			die "$p: trigger script does not match pkgname or any subpackage"
		fi
Natanael Copa's avatar
Natanael Copa committed
184

185 186
		[ -e "$startdir"/$f ] || die "trigger script $f is missing"
	done
187 188
	if [ -n "$source" ]; then
		for i in $source; do
Natanael Copa's avatar
Natanael Copa committed
189 190 191 192
			if install_has "$i"; then
				warning "You should not have \$install in source"
				continue
			fi
193
			md5sums_has ${i##*/} || die "${i##*/} is missing in md5sums"
Natanael Copa's avatar
Natanael Copa committed
194
			case "$i" in
195
				https://*) makedepends_has wget && warning "wget no longer need to be in makedepends when source has https://" ;;
Natanael Copa's avatar
Natanael Copa committed
196
			esac
197 198
		done
	fi
Natanael Copa's avatar
Natanael Copa committed
199

200 201
	if [ -n "$md5sums" ]; then
		for i in $(echo "$md5sums" | awk '{ print $2 }'); do
Natanael Copa's avatar
Natanael Copa committed
202
			source_has $i || die "$i exists in md5sums but is missing in source"
203 204
		done
	fi
205

206 207 208
	# common spelling errors
	[ -n "$depend" ] && die "APKBUILD contains 'depend'. It should be depends"
	[ -n "$makedepend" ] && die "APKBUILD contains 'makedepend'. It should be makedepends"
Natanael Copa's avatar
Natanael Copa committed
209 210

	grep '^# Maintainer:' $APKBUILD >/dev/null || warning "No maintainer"
211 212

	makedepends_has 'g++' && warning "g++ should not be in makedepends"
213 214 215
	return 0
}

216 217 218 219
sanitycheck() {
	default_sanitycheck
}

220 221
sumcheck() {
	local algo="$1" sums="$2"
222
	local dummy f endreturnval originalparams origin file
223 224 225 226 227 228 229 230

	# get number of checksums
	set -- $sums
	local numsums=$(( $# / 2 ))

	set -- $source
	if [ $# -ne $numsums ]; then
		die "Number of ${algo}sums($numsums) does not correspond to number of sources($#)"
231
	fi
232
	fetch || return 1
233
	msg "Checking ${algo}sums..."
Natanael Copa's avatar
Natanael Copa committed
234
	cd "$srcdir" || return 1
235 236
	IFS=$'\n'
	endreturnval=0
237
	for src in $sums; do
238
		origin=$1; shift
239
		echo "$src" | ${algo}sum -c
240
		if [ $? -ne 0 ]; then
241
			endreturnval=1
242
			is_remote $origin || continue
243
			echo "Because the remote file above failed the ${algo}sum check it will be deleted."
244 245 246 247 248 249 250 251
			echo "Rebuilding will cause it to re-download which in some cases may fix the problem."
			file=`echo "$src" | sed 's/.*[ \t\n]\(.*\)/\1/'`
			echo "Deleting: $file"
			rm $file
		fi
	done
	unset IFS
	return $endreturnval
Natanael Copa's avatar
Natanael Copa committed
252 253
}

254 255 256 257 258 259 260 261 262 263 264 265 266 267 268 269 270 271 272 273 274 275 276 277
# for compatibility
md5check() {
	warning "'md5check' is deprecated. Use 'verify' instead"
	sumcheck md5 "$md5sums"
}

# verify checksums
verify() {
	local verified=false algo=
	for algo in md5 sha1 sha256 sha512; do
		local sums=
		eval sums=\"\$${algo}sums\"
		if [ -z "$sums" ] || [ -z "$source" ]; then
			continue
		fi
		sumcheck "$algo" "$sums" || return 1
		verified=true
	done
	if [ -n "$source" ] && ! $verified; then
		die "Use 'abuild checksum' to generate/update the checksum(s)"
	fi
	return 0
}

Natanael Copa's avatar
Natanael Copa committed
278 279
# verify upstream sources
sourcecheck() {
280 281 282 283 284 285 286 287 288 289
	local uri
	for uri in $source; do
		is_remote $uri || continue
		case "$uri" in
		saveas-*://*)
			uri=${uri#saveas-}
			uri=${uri%/*}
			;;
		esac
		wget -q -s "$uri" || return 1
Natanael Copa's avatar
Natanael Copa committed
290
	done
291
	return 0
Natanael Copa's avatar
Natanael Copa committed
292
}
293

294 295 296
# convert curl options to wget options and call wget instead of curl
wget_fallback() {
	local wget_opts= outfile= opt=
297
	while getopts "C:Lko:s" opt; do
298
		case $opt in
299
		'L') ;; # --location. wget does this by default
300
		'f') ;; # --fail. wget does this by default
301 302 303 304 305 306 307 308 309 310
		'C') wget_opts="$wget_opts -c";; # --continue-at
		's') wget_opts="$wget_opts -q";; # --silent
		'o') wget_opts="$wget_opts -O $OPTARG";; # --output
		'k') wget_opts="$wget_opts --no-check-certificate";; #gnu wget
		esac
	done
	shift $(( $OPTIND - 1 ))
	wget $wget_opts "$1"
}

Natanael Copa's avatar
Natanael Copa committed
311 312
uri_fetch() {
	local uri="$1"
313
	local d="${uri##*/}"	# $(basename $uri)
314
	local opts
315
	[ -n "$quiet" ] && opts="-s"
316 317

	local lockfile="$SRCDEST/$d".lock
318

319 320 321 322 323
	# fix saveas-*://* URIs
	case "$uri" in
		# remove 'saveas-' from beginning and
		# '/filename' from end of URI
		saveas-*://*) uri="${uri:7:$(expr ${#uri} - 7 - ${#d} - 1)}";;
Natanael Copa's avatar
Natanael Copa committed
324
	esac
325 326

	case "$uri" in
327
		https://*) opts="-k";;
328
	esac
329

Natanael Copa's avatar
Natanael Copa committed
330
	mkdir -p "$SRCDEST"
331 332 333

	CLEANUP_FILES="$CLEANUP_FILES $lockfile"
	(
334 335
	flock -n -x 9 || msg "Waiting for ${lockfile##*/}..."
	flock -x 9
336 337 338

	[ -f "$SRCDEST/$d" ] && exit 0 # use exit since its a subshell

339 340
	if [ -f "$SRCDEST/$d.part" ]; then
		msg "Partial download found. Trying to resume"
341
		opts="$opts -C -"
Natanael Copa's avatar
Natanael Copa committed
342
	fi
Linux User's avatar
Linux User committed
343
	msg "Fetching $uri"
344 345

	# fallback to wget if curl is missing. useful for bootstrapping
346
	local fetcher=
347 348
	if ! [ -x "$(which curl)" ]; then
		fetcher=wget_fallback
349 350
	else
		fetcher=curl
351
		opts="$opts -L -f -k"
352 353 354
	fi

	$fetcher $opts -o "$SRCDEST/$d.part" "$uri" \
355
		&& mv "$SRCDEST/$d.part" "$SRCDEST/$d"
356

357
	) 9>$lockfile
358 359 360 361

	local rc=$?
	rm -f "$lockfile"
	return $rc
Natanael Copa's avatar
Natanael Copa committed
362 363
}

364 365
is_remote() {
	case "$1" in
366
		http://*|ftp://*|https://*|saveas-*://*)
367 368 369 370 371
			return 0;;
	esac
	return 1
}

372 373 374 375 376
# try download from file from mirror first
uri_fetch_mirror() {
	local uri="$1"
	local d="${uri##*/}"	# $(basename $uri)
	if [ -n "$DISTFILES_MIRROR" ]; then
377 378 379 380 381
		if is_remote "$DISTFILES_MIRROR"; then
			uri_fetch "$DISTFILES_MIRROR"/$d && return 0
		else
			cp "$DISTFILES_MIRROR"/$d "$SRCDEST" && return 0
		fi
382 383 384 385
	fi
	uri_fetch "$uri"
}

386
default_fetch() {
Natanael Copa's avatar
Natanael Copa committed
387 388
	local s
	mkdir -p "$srcdir"
389 390
	for s in $source; do
		if is_remote "$s"; then
391
			uri_fetch_mirror "$s" || return 1
392 393 394 395
			ln -sf "$SRCDEST/${s##*/}" "$srcdir"/
		else		
			ln -sf "$startdir/$s" "$srcdir/"
		fi
Natanael Copa's avatar
Natanael Copa committed
396 397 398
	done
}

399 400 401 402
fetch() {
	default_fetch
}

Natanael Copa's avatar
Natanael Copa committed
403 404 405 406 407 408 409 410 411 412 413 414 415 416 417
# verify that all init.d scripts are openrc runscripts
initdcheck() {
	local i
	for i in $source; do
		case $i in
		*.initd)
			head -n 1 "$srcdir"/$i | grep -q '/sbin/runscript' \
				&& continue
			error "$i is not an openrc #!/sbin/runscript"
			return 1
			;;
		esac
	done			
}

Natanael Copa's avatar
Natanael Copa committed
418
# unpack the sources
419
default_unpack() {
Natanael Copa's avatar
Natanael Copa committed
420
	local u
421 422
	if [ -z "$force" ]; then
		md5check || return 1
Natanael Copa's avatar
Natanael Copa committed
423
		initdcheck || return 1
424
	fi
Natanael Copa's avatar
Natanael Copa committed
425 426 427 428
	mkdir -p "$srcdir"
	for u in $source; do
		local s="$SRCDEST/${u##*/}"	# $(basename $s)
		case "$s" in
429 430 431
			*.tar)
				msg "Unpacking $s..."
				tar -C "$srcdir" -xf "$s" || return 1;;
Natanael Copa's avatar
Natanael Copa committed
432
			*.tar.gz|*.tgz)
433
				msg "Unpacking $s..."
Natanael Copa's avatar
Natanael Copa committed
434 435
				tar -C "$srcdir" -zxf "$s" || return 1;;
			*.tar.bz2)
436
				msg "Unpacking $s..."
Natanael Copa's avatar
Natanael Copa committed
437
				tar -C "$srcdir" -jxf "$s" || return 1;;
438 439 440 441
			*.tar.lzma)
				msg "Unpacking $s..."
				unlzma -c "$s" | tar -C "$srcdir" -x  \
					|| return 1;;
442 443 444
			*.tar.xz)
				msg "Unpacking $s..."
				unxz -c "$s" | tar -C "$srcdir" -x || return 1;;
Natanael Copa's avatar
Natanael Copa committed
445 446 447
			*.zip)
				msg "Unpacking $s..."
				unzip "$s" -d "$srcdir" || return 1;;
Natanael Copa's avatar
Natanael Copa committed
448 449 450 451
		esac
	done
}

452 453 454 455
unpack() {
	default_unpack
}

Natanael Copa's avatar
Natanael Copa committed
456 457
# cleanup source and package dir
clean() {
458
	msg "Cleaning temporary build dirs..."
Natanael Copa's avatar
Natanael Copa committed
459
	rm -rf "$srcdir"
460
	rm -rf "$pkgbasedir"
Natanael Copa's avatar
Natanael Copa committed
461 462 463 464 465 466
}

# cleanup fetched sources
cleancache() {
	local s
	for s in $source; do
467 468 469 470
		if is_remote "$s"; then
			msg "Cleaning downloaded ${s##*/}..."
			rm -f "$SRCDEST/${s##*/}"
		fi
Natanael Copa's avatar
Natanael Copa committed
471 472 473
	done
}

474 475 476 477 478 479 480 481 482 483
listpkgnames() {
	local i
	for i in $pkgname $subpackages; do
		echo ${i%:*}
	done
	for i in $linguas; do
		echo $pkgname-lang-$i
	done
}

Natanael Copa's avatar
Natanael Copa committed
484 485
cleanpkg() {
	local i
486
	getpkgver || return 1
487
	msg "Cleaning built packages..."
488
	for i in $(listpkgnames); do
489 490
		local p="${i%:*}-$pkgver-r$pkgrel"
		rm -f "$PKGDEST/$p.apk" "$PKGDEST/$p.src.tar.gz" \
491
			"$abuildrepo"/$p.apk "$abuildrepo"/*/$p.apk
Natanael Copa's avatar
Natanael Copa committed
492
	done
493
	# remove given packages from index
Natanael Copa's avatar
Natanael Copa committed
494 495
}

496 497 498
# clean all packages except current
cleanoldpkg() {
	local i j
499
	getpkgver || return 1
500
	msg "Cleaning all packages except $pkgver-r$pkgrel..."
501
	for i in $(listpkgnames); do
502 503 504 505 506
		local pn=${i%:*}
		for j in "$PKGDEST"/$pn-[0-9]*.apk ; do
			[ "$j" = "$PKGDEST/$pn-$pkgver-r$pkgrel.apk" ] \
				&& continue
			rm -f "$j" "$abuildrepo"/*/${j##*/}
507 508 509 510
		done
	done
	return 0
}
511 512 513

mkusers() {
	local i
514 515 516 517 518 519
	for i in $pkggroups; do
		if ! getent group $i >/dev/null; then
			msg "Creating group $i"
			$ADDGROUP -S $i || return 1
		fi
	done
520 521
	for i in $pkgusers; do
		if ! getent passwd $i >/dev/null; then
522
			local gopt=
523
			msg "Creating user $i"
524 525 526
			if getent group $i >/dev/null; then
				gopt="-G $i"
			fi
527
			$ADDUSER -S -D -H $gopt $i || return 1
528 529 530 531 532
		fi
	done
}


Natanael Copa's avatar
Natanael Copa committed
533 534
runpart() {
	local part=$1
535
	[ -n "$DEBUG" ] && msg "$part"
Natanael Copa's avatar
Natanael Copa committed
536 537 538 539
	$part || die "$part failed"
}

# override those in your build script
540 541 542 543 544 545 546 547
getpkgver() {
	# this func is supposed to be overridden by volatile packages
	if [ "$pkgver" = "volatile" ]; then
		error "Please provide a getpkgver() function in your APKBUILD"
		return 1
	fi
}

Natanael Copa's avatar
Natanael Copa committed
548 549 550 551
prepare() {
	:
}

Natanael Copa's avatar
Natanael Copa committed
552
build() {
553
	:
Natanael Copa's avatar
Natanael Copa committed
554 555
}

556 557 558
# generate a simple tar.gz package of pkgdir
targz() {
	cd "$pkgdir" || return 1
Natanael Copa's avatar
Natanael Copa committed
559
	mkdir -p "$PKGDEST"
560 561 562
	tar -czf "$PKGDEST"/$pkgname-$pkgver-r$pkgrel.tar.gz *
}

Natanael Copa's avatar
Natanael Copa committed
563 564 565 566 567 568 569 570 571
get_split_func() {
	# get the 'func' from "sub-pkg:func"
	local func=${1##*:}

	# get 'func' from "sub-pkg-func" if there was no :func
	[ "$func" = "$1" ] && func=${func##*-}
	echo $func
}

572 573 574
postcheck() {
	local dir="$1" name="$2" i=
	msg "Running postcheck for $name"
575
	# checking for FHS compat
Natanael Copa's avatar
Natanael Copa committed
576 577 578 579 580 581 582 583
	if ! options_has "!fhs"; then
		for i in "$dir"/srv/* "$dir"/usr/local/* "$dir"/opt/*; do
			if [ -e "$i" ]; then
				error "Packages must not put anything under /srv, /usr/local or /opt"
				return 1
			fi
		done
	fi
584 585 586 587 588 589 590 591 592 593 594 595 596
	# look for *.la files
	i=$(find "$dir" -name '*.la' | sed "s|^$dir|\t|")
	if [ -n "$i" ] && ! options_has "libtool"; then
		error "Libtool archives (*.la) files found and \$options has no 'libtool' flag:"
		echo "$i"
		return 1
	fi
	# check directory permissions
	i=$(find "$dir" -type d -perm -777 | sed "s|^$dir|\t|")
	if [ -n "$i" ]; then
		warning "World writeable directories found:"
		echo "$i"
	fi
597 598 599 600 601 602 603 604 605
	# check so we dont have any suid root binaries that are not 
	i=$(find "$dir" -type f -perm +6000 \
		| xargs scanelf --nobanner --etype ET_EXEC \
		| sed "s|ET_EXEC $dir|\t|")
	if [ -n "$i" ]; then
		error "Found non-PIE files that has SUID:"
		echo "$i"
		return 1
	fi
Natanael Copa's avatar
Natanael Copa committed
606 607 608 609 610 611 612 613 614
	# test for textrels
	if ! options_has "textrels"; then
		local res="$(scanelf --recursive --textrel --quiet "$dir")"
		if [ -n "$res" ]; then
			error "Found textrels:"
			echo "$res"
			return 1
		fi
	fi
615 616 617
	return 0
}

618
prepare_subpackages() {
Natanael Copa's avatar
Natanael Copa committed
619 620
	local i
	cd "$startdir"
621
	for i in $subpackages; do
Natanael Copa's avatar
Natanael Copa committed
622 623
		local func=$(get_split_func $i)
		# call abuild recursively, setting subpkg{dir,name}
624
		msg "Running split function $func..."
625 626
		local dir="$pkgbasedir/${i%:*}" name="${i%:*}"
		subpkgdir="$dir" subpkgname="$name" \
627
			$0 $func prepare_package || return 1
628
		postcheck "$dir" "$name" || return 1
Natanael Copa's avatar
Natanael Copa committed
629
	done
630
	postcheck "$pkgdir" "$pkgname" || return 1
631 632
	# post check for /usr/share/locale
	if [ -d "$pkgdir"/usr/share/locale ]; then
633
		warning "Found /usr/share/locale"
634
		warning2 "Maybe add \$pkgname-lang to subpackages?"
635
	fi
Natanael Copa's avatar
Natanael Copa committed
636 637
}

638
default_lang() {
639
	pkgdesc="Languages for package $pkgname"
640 641 642 643 644 645 646 647 648 649 650 651 652
	install_if="$pkgname=$pkgver-r$pkgrel lang"
	arch="noarch"
	local dir
	for dir in ${langdir:-/usr/share/locale}; do
		mkdir -p "$subpkgdir"/${dir%/*}
		mv "$pkgdir"/"$dir" "$subpkgdir"/"$dir" || return 1
	done
}

lang() {
	default_lang
}

653
default_lang_subpkg() {
654 655 656 657
	if [ -z "$lang" ]; then
		error "lang is not set"
		return 1
	fi
658
	pkgdesc="$pkgname language pack for $lang"
659 660
	arch="noarch"
	install_if="$pkgname=$pkgver-r$pkgrel lang-$lang"
661 662 663 664 665
	local dir
	for dir in ${langdir:-/usr/share/locale}; do
		mkdir -p "$subpkgdir"/$dir
		mv "$pkgdir"/$dir/$lang* \
		"$subpkgdir"/$dir/ \
666
		|| return 1
667 668 669 670 671
	done
}

lang_subpkg() {
	default_lang_subpkg
672 673 674 675 676 677 678 679 680 681 682
}

prepare_language_packs() {
	for lang in $linguas; do
		lang="$lang" \
		subpkgname="$pkgname-lang-$lang" \
		subpkgdir="$pkgbasedir"/$subpkgname \
			$0 lang_subpkg prepare_package || return 1
	done
}

683 684 685 686 687 688 689 690 691 692 693 694
# echo '-dirty' if git is not clean
git_dirty() {
	if [ $(git status -s "$startdir" | wc -l) -ne 0 ]; then
		echo "-dirty"
	fi
}

# echo last commit hash id
git_last_commit() {
	git log --format=oneline -n 1 "$startdir" | awk '{print $1}'
}

695 696 697 698 699 700
get_maintainer() {
	if [ -z "$maintainer" ]; then
		maintainer=$(awk -F': ' '/\# *Maintainer/ {print $2}' "$APKBUILD")
	fi
}

701
prepare_metafiles() {
702
	getpkgver || return 1
703 704
	local name=${subpkgname:-$pkgname}
	[ -z "${name##* *}" ] && die "package name contains spaces"
705
	local dir=${subpkgdir:-$pkgdir}
706
	local pkg="$name-$pkgver-r$pkgrel.apk"
707
	local pkginfo="$controldir"/.PKGINFO
708
	local sub
Natanael Copa's avatar
Natanael Copa committed
709 710 711
	
	[ ! -d "$dir" ] && die "Missing $dir"
	cd "$dir"
712
	mkdir -p "$controldir"
Natanael Copa's avatar
Natanael Copa committed
713 714
	local builddate=$(date -u "+%s")
	local size=$(du -sk | awk '{print $1 * 1024}')
Natanael Copa's avatar
Natanael Copa committed
715
	local parch="$CARCH"
716 717 718 719 720

	# we need to wait with setting noarch til our build infra can handle it
#	if [ "$arch" = "noarch" ]; then
#		parch="noarch"
#	fi
Natanael Copa's avatar
Natanael Copa committed
721

722
	echo "# Generated by $(basename $0) $abuild_ver" >"$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
723
	if [ -n "$FAKEROOTKEY" ]; then
724
		echo "# using $($FAKEROOT -v)" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
725
	fi
726 727
	echo "# $(date -u)" >> "$pkginfo"
	cat >> "$pkginfo" <<EOF
728
pkgname = $name
729
pkgver = $pkgver-r$pkgrel
Natanael Copa's avatar
Natanael Copa committed
730 731 732 733 734
pkgdesc = $pkgdesc
url = $url
builddate = $builddate
packager = ${PACKAGER:-"Unknown"}
size = $size
Natanael Copa's avatar
Natanael Copa committed
735
arch = $parch
Natanael Copa's avatar
Natanael Copa committed
736
origin = $pkgname
Natanael Copa's avatar
Natanael Copa committed
737
EOF
738 739
	local i deps
	deps="$depends"
740
	if [ "$pkgname" != "busybox" ] && ! depends_has busbox; then
741 742
		for i in $install $triggers; do
			local s=${i%=*}
743
			[ "$name" != "${s%.*}" ] && continue
744
			if head -n 1 "$startdir/$s" | grep '^#!/bin/sh' >/dev/null ; then
745 746 747 748 749
				msg "Script found. busybox added as a dependency for $pkg"
				deps="$deps busybox"
				break
			fi
		done
750 751
	fi
	
752 753 754 755 756 757 758 759 760 761
	local last_commit="$(git_last_commit)$(git_dirty)"
	if [ -n "$last_commit" ]; then
		echo "commit = $last_commit" >> "$pkginfo"
	fi

	get_maintainer
	if [ -n "$maintainer" ]; then
		echo "maintainer = $maintainer" >> "$pkginfo"
	fi

762
	if [ -n "$replaces_priority" ]; then
Natanael Copa's avatar
Natanael Copa committed
763
		echo "replaces_priority = $replaces_priority" >> "$pkginfo"
764 765
	fi

Natanael Copa's avatar
Natanael Copa committed
766
	for i in $license; do
767
		echo "license = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
768 769
	done
	for i in $replaces; do
770
		echo "replaces = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
771
	done
772
	for i in $deps; do
773
		echo "depend = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
774 775
	done
	for i in $conflicts; do
776
		echo "conflict = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
777 778
	done
	for i in $provides; do
779
		echo "provides = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
780
	done
781 782 783 784 785 786
	for i in $triggers; do
		local f=${i%=*}
		local dirs=${i#*=}
		[ "${f%.trigger}" != "$name" ] && continue
		echo "triggers = ${dirs//:/ }" >> "$pkginfo"
	done
787 788 789
	if [ -n "$install_if" ]; then
		echo "install_if = $(echo $install_if)" >> "$pkginfo"
	fi
Natanael Copa's avatar
Natanael Copa committed
790 791

	local metafiles=".PKGINFO"
792 793 794
	for i in $install $triggers; do
		local f=${i%=*}
		local n=${f%.*}
795
		if [ "$n" != "$name" ]; then
796 797
			continue
		fi
798
		script=${f#$name}
799
		msg "Adding $script"
800
		cp "$startdir/$f" "$controldir/$script" || return 1
801
		chmod +x "$controldir/$script"
802 803
		metafiles="$metafiles $script"
	done
804
	echo $metafiles | tr ' ' '\n' > "$controldir"/.metafiles
805
}
806

807 808
prepare_tracedeps() {
	local dir=${subpkgdir:-$pkgdir}
809
	local etype= soname= file= sover=
810
	[ "$arch" = "noarch" ] && return 0
811
	options_has "!tracedeps" && return 0
812
	# lets tell all the places we should look for .so files - all rpaths
813 814
	scanelf --quiet --recursive --rpath "$dir" \
		| sed -e 's/[[:space:]].*//' -e 's/:/\n/' | sort -u \
815
		>"$controldir"/.rpaths
816 817 818 819 820 821 822
	if grep -q -x '/usr/lib' "$controldir"/.rpaths; then
		warning "Redundat /usr/lib in rpath found"
	fi
	if grep '^/home/' "$controldir"/.rpaths; then
		error "Has /home/... in rpath"
		return 1
	fi
Natanael Copa's avatar
Natanael Copa committed
823 824
}

825 826 827 828 829 830 831 832 833 834 835 836
# check if dir has arch specific binaries
dir_has_arch_binaries() {
	local dir="$1"
	# if scanelf returns something, then we have binaries
	[ -n "$(scanelf -R "$dir" | head -n 1)" ] && return 0

	# look for static *.a
	[ -n "$(find "$dir" -type f -name '*.a' | head -n 1)" ] && return 0

	return 1
}

837 838 839 840 841
# returns true if this is the -dev package
is_dev_pkg() {
	test "${subpkgname%-dev}" != "$subpkgname"
}

842 843 844 845 846 847 848
# check that noarch is set if needed
archcheck() {
	options_has "!archcheck" && return 0
	if dir_has_arch_binaries "${subpkgdir:-$pkgdir}"; then
		[ "$arch" != "noarch" ] && return 0
		error "Arch specific binaries found so arch must not be set to \"noarch\""
		return 1
849 850 851
	elif [ "$arch" != "noarch" ] && ! is_dev_pkg; then
		# we dont want -dev package go to noarch
		warning "No arch specific binaries found so arch should probably be set to \"noarch\""
852 853 854 855
	fi
	return 0
}

856
prepare_package() {
857
	msg "Preparing ${subpkgname:+sub}package ${subpkgname:-$pkgname}..."
858
	stripbin
859 860
	prepare_metafiles && prepare_tracedeps || return 1
	archcheck	
861 862 863 864 865 866 867 868
}

pkginfo_val() {
	local key="$1"
	local file="$2"
	awk -F ' = ' "\$1 == \"$key\" {print \$2}" "$file"
}

869 870 871 872 873 874 875 876 877 878 879 880 881 882 883 884 885 886 887 888 889 890 891
# find real path to so files
real_so_path() {
	local so="$1"
	shift
	while [ $# -gt 0 ]; do
		[ -e "$1"/$so ] && realpath "$1/$so" && return 0
		shift
	done
	error "$so: path not found"
	return 1
}

# search rpaths and /usr/lib /lib for given so files
find_so_files() {
	local rpaths=$(cat "$1")
	shift
	while [ $# -gt 0 ]; do
		real_so_path "$1" /usr/lib /lib $rpaths || return 1
		shift
	done
	return 0
}

892 893 894 895
subpkg_provides() {
	grep -q -w "^$1" "$pkgbasedir"/.control.*/.provides-so 2>/dev/null
}

896 897 898
trace_apk_deps() {
	local name="$1"
	local dir="$2"
899
	local i= found= autodeps= deppkgs= missing=
900
	msg "Tracing dependencies..."
901 902 903
	# add pkgconfig if usr/lib/pkgconfig is found
	if [ -d "$pkgbasedir"/$name/usr/lib/pkgconfig ] \
			&& ! grep -q '^depend = pkgconfig' "$dir"/.PKGINFO; then
904
		msg "  added pkgconfig (found /usr/lib/pkgconfig)"
905 906 907 908
		autodeps="$autodeps pkgconfig"
	fi

	# special case for libpthread: we need depend on libgcc
909
	if [ -f "$dir"/.needs-so ] && grep -q -w '^libpthread.so.*' "$dir"/.needs-so \
910 911
			&& ! grep -q -w "^depend = libgcc" "$dir"/.PKGINFO; then
		autodeps="$autodeps libgcc"
912
		msg "  added libgcc (due to libpthread)"
913
	fi
914
	[ -f "$dir"/.needs-so ] && for i in $(cat "$dir"/.needs-so); do
915 916 917 918 919
		# first check if its provided by same apkbuild
		grep -q -w "^$i" "$dir"/.provides-so 2>/dev/null && continue

		if subpkg_provides "$i" || $APK info -q -e "so:$i"; then
			autodeps="$autodeps so:$i"
920
		else
921
			missing="$missing $i"
922
		fi
923 924 925
	done

	# find all packages that holds the so files
926
	if [ -f "$dir"/.rpaths ]; then
927 928
		local so_files=$(find_so_files "$dir"/.rpaths $missing) \
			|| return 1
929 930 931
		deppkgs=$($APK info -q -W $so_files) || return 1
	fi

932
	for found in $deppkgs; do
933
		if grep -w "^depend = ${found}$" "$dir"/.PKGINFO >/dev/null ; then
934 935 936
			warning "You can remove '$found' from depends"
			continue
		fi
937
		autodeps="$autodeps $found"
938
	done
939

940
	echo "# automatically detected:" >> "$dir"/.PKGINFO
941
	if [ -f "$dir"/.provides-so ]; then
942
		sed 's/^\(.*\) \([0-9].*\)/provides = so:\1=\2/' "$dir"/.provides-so \
943
			>> "$dir"/.PKGINFO
944 945
	fi
	[ -z "$autodeps" ] && return 0
946
	for i in $autodeps; do
947 948
		echo "depend = $i"
	done | sort -u >> "$dir"/.PKGINFO
949 950
	# display all depends
	sed -n '/^depend =/s/depend = /\t/p' "$dir"/.PKGINFO >&2
951 952
}

953
find_scanelf_paths() {
954
	local datadir="$1"
Natanael Copa's avatar
Natanael Copa committed
955
	local paths="$datadir/lib:$datadir/usr/lib" i= rpaths=
956
	if [ -n "$ldpath" ]; then
957
		paths="$paths:$(echo "$ldpath" | sed "s|\(^\|:\)|\1$datadir|g")"
958 959
	fi
	# search in all rpaths
Natanael Copa's avatar
Natanael Copa committed
960 961
	for rpaths in "$pkgbasedir"/.control.*/.rpaths; do
		[ -f "$rpaths" ] || continue
962
		while read i; do
963 964 965 966
			local dir="${datadir}${i}"
			IFS=:
			if [ -d "$dir" ] && ! list_has "$dir" $paths; then
				paths="$paths:${dir}"
967
			fi
968
			unset IFS
Natanael Copa's avatar
Natanael Copa committed
969
		done < "$rpaths"
970 971 972 973 974 975
	done
	echo "$paths"
}

scan_shared_objects() {
	local name="$1" controldir="$2" datadir="$3"
976
	local opt=
977 978 979

	# allow spaces in paths
	IFS=:
980
	set -- $(find_scanelf_paths "$datadir")
981 982
	unset IFS

983 984 985
	if options_has "ldpath-recursive"; then
		opt="--recursive"
	fi
986 987
	msg "Scanning shared objects"
	# lets tell all the .so files this package provides in .provides-so
988
	scanelf --nobanner --soname $opt "$@" | while read etype soname file; do
989 990
		# if soname field is missing, soname will be the filepath
		sover=0
991 992
		if [ -z "$file" ]; then
			file="$soname"
993
			soname=${soname##*/}
994 995 996 997 998 999 1000 1001 1002 1003 1004 1005 1006 1007
		fi

		# we only want shared libs
		case $soname in
		*.so|*.so.[0-9]*);;
		*) continue;;
		esac

		case "$file" in
		*.so.[0-9]*) sover=${file##*.so.};;
		*.so)
			# filter out sonames with version when file does not
			# have version
			case "$soname" in
1008 1009 1010 1011
			*.so.[0-9]*)
				if options_has "sover-namecheck"; then
					continue
				fi
1012 1013 1014
			esac
			;;
		esac
Natanael Copa's avatar
Natanael Copa committed
1015
		list_has "$soname" $somask && continue
1016
		echo "$soname $sover"
1017 1018 1019 1020 1021 1022 1023 1024 1025 1026
	# use awk to filter out dupes that has sover = 0
	done | awk '{ if (so[$1] == 0) so[$1] = $2; }
		END { for (i in so) print(i " " so[i]); }' \
		| sort -u > "$controldir"/.provides-so

	# verify that we dont have any duplicates
	local dupes="$(cut -d' ' -f1 "$controldir"/.provides-so | uniq -d)"
	if [ -n "$dupes" ]; then
		die  "provides multiple versions of same shared object: $dupes"
	fi
1027 1028 1029 1030 1031

	# now find the so dependencies
	scanelf --nobanner --recursive --needed "$datadir"  | tr ' ' ':' \
		| awk -F ":" '$1 == "ET_DYN" || $1 == "ET_EXEC" {print $2}'  \
		| sed 's:,:\n:g' | sort -u \
Natanael Copa's avatar
Natanael Copa committed
1032
	| while read soname; do
1033
		# only add files that are not self provided
Natanael Copa's avatar
Natanael Copa committed
1034 1035 1036
		grep -q -w "^$soname" "$controldir"/.provides-so \
			|| list_has "$soname" $somask \
			|| echo $soname
1037 1038 1039
	done > "$controldir"/.needs-so
}

1040 1041 1042 1043 1044 1045 1046 1047
# read size in bytes from stdin and show as human readable
human_size() {
	awk '{  split("B KB MB GB TB PB", type)
		for(i=5; y < 1; i--)
			y = $1 / (2**(10*i))
		printf("%.1f %s\n", y, type[i+2]) }'
}

1048
create_apks() {
1049
	local file= dir= name= ver= apk= datadir= size=
1050
	getpkgver || return 1
Natanael Copa's avatar
Natanael Copa committed
1051
	mkdir -p "$PKGDEST"
1052 1053 1054 1055 1056 1057 1058 1059 1060
	if [ "$arch" != "noarch" ] && ! options_has "!tracedeps"; then
		for file in "$pkgbasedir"/.control.*/.PKGINFO; do
			dir="${file%/.PKGINFO}"
			name="$(pkginfo_val pkgname $file)"
			datadir="$pkgbasedir"/$name
			subpkgname=$name
			scan_shared_objects "$name" "$dir" "$datadir"
		done
	fi
1061
	for file in "$pkgbasedir"/.control.*/.PKGINFO; do
1062 1063 1064
		dir="${file%/.PKGINFO}"
		name=$(pkginfo_val pkgname $file)
		ver=$(pkginfo_val pkgver $file)
1065
		size=$(pkginfo_val size $file | human_size)
1066 1067 1068
		apk=$name-$ver.apk
		datadir="$pkgbasedir"/$name
		subpkgname=$name
1069 1070

		trace_apk_deps "$name" "$dir" || return 1
1071
		msg "Package size: ${size}"
1072
		msg "Compressing data..."
1073
		(
1074 1075
		cd "$datadir"
		# data.tar.gz
1076 1077 1078 1079 1080 1081
		set -- *
		if [ "$1" = '*' ]; then
			touch .dummy
			set -- .dummy
		fi
		tar -c "$@" | abuild-tar --hash | gzip -9 >"$dir"/data.tar.gz
1082

1083
		msg "Create checksum..."
1084 1085 1086 1087 1088
		# append the hash for data.tar.gz
		local sha256=$(sha256sum "$dir"/data.tar.gz | cut -f1 -d' ')
		echo "datahash = $sha256" >> "$dir"/.PKGINFO

		# control.tar.gz
1089
		cd "$dir"
1090 1091
		tar -c $(cat "$dir"/.metafiles) | abuild-tar --cut \
			| gzip -9 > control.tar.gz
1092
		abuild-sign -q control.tar.gz || exit 1
Natanael Copa's avatar
Natanael Copa committed
1093

1094
		msg "Create $apk"
1095 1096
		# create the final apk
		cat control.tar.gz data.tar.gz > "$PKGDEST"/$apk
1097
		)
1098
	done
1099
	subpkgname=
1100 1101
}

1102
clean_abuildrepo() {
1103
	local apk
1104 1105 1106
	cd "$abuildrepo" || return 1
	
	# remove compat symlink
1107
	for d in "$abuildrepo/$CARCH"; do
1108 1109
		[ -L "$d" ] && rm "$d"
	done
1110

1111 1112
	# remove broken links from abuildrepo
	for apk in *.apk */*.apk; do
1113 1114 1115 1116
		if [ -L "$apk" ] && [ ! -f "$apk" ]; then
			rm -f "$apk"
		fi
	done
1117
}
1118

1119
mklinks_abuildrepo() {
1120 1121
	local apk
	mkdir -p "$abuildrepo"/$CARCH
1122
	cd "$abuildrepo" || return 1
1123
	# create links for this package
1124
	for apk in $(listpkg); do
1125
		[ -f "$PKGDEST"/$apk ] || continue
1126
		ln -sf "$PKGDEST"/$apk "$abuildrepo"/$CARCH/$apk
1127
	done
1128 1129 1130 1131 1132 1133 1134 1135 1136 1137 1138 1139 1140 1141
}

update_abuildrepo() {
	local d apk
	if ! apk_up2date || [ -n "$force" ]; then
		sanitycheck && builddeps && clean && fetch && unpack \
			&& prepare && mkusers && rootpkg || return 1
	fi

	clean_abuildrepo
	mklinks_abuildrepo

	cd "$abuildrepo"
	local index=$CARCH/APKINDEX.tar.gz
1142

1143
	msg "Updating the cached abuild repository index..."
1144 1145
	local sign=".SIGN.RSA.${SIGN_PUBLIC_KEY##*/}"
	local oldindex=
1146 1147
	if [ -f "$index" ]; then
		oldindex="--index $index"
1148
	fi
1149
	$APK index --quiet $oldindex --output "$index".unsigned \
1150
		--description "$repo $(cd $startdir && git describe)" \
Natanael Copa's avatar